MODULE_NAME='ClearoneConvergePro2AnalogDialer' (DEV vdvDialer, DEV dvPanel)
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/04/2006  AT: 11:33:16        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)    
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
#INCLUDE 'SNAPI'

DEFINE_CONSTANT

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE CHAR bDTMFSend;
VOLATILE CHAR cDialNumber[25];

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

////////////////////////////////////////////////////////////
// DIAL KEYPAD 
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, 131]					// DIGIT 0
BUTTON_EVENT[dvPanel, 132]					// DIGIT 1
BUTTON_EVENT[dvPanel, 133]					// DIGIT 2
BUTTON_EVENT[dvPanel, 134]					// DIGIT 3
BUTTON_EVENT[dvPanel, 135]					// DIGIT 4
BUTTON_EVENT[dvPanel, 136]					// DIGIT 5
BUTTON_EVENT[dvPanel, 137]					// DIGIT 6
BUTTON_EVENT[dvPanel, 138]					// DIGIT 7
BUTTON_EVENT[dvPanel, 139]					// DIGIT 8
BUTTON_EVENT[dvPanel, 140]					// DIGIT 9
BUTTON_EVENT[dvPanel, 141]					// DIGIT *
BUTTON_EVENT[dvPanel, 142]					// DIGIT #
{                   
	PUSH:
	{
		STACK_VAR INTEGER nButton;
		STACK_VAR CHAR cDigit[1];
		
		nButton = BUTTON.INPUT.CHANNEL - 131;
		
		TO[BUTTON.INPUT];
		
		SWITCH (nButton)
		{
			CASE 10:
			{
				cDigit = '*';
				BREAK;
			}
			CASE 11:
			{
				cDigit = '#';
				BREAK;
			}
			DEFAULT:
			{
				cDigit = ITOA(nButton);
				BREAK;
			}
		}

		cDialNumber = "cDialNumber, cDigit"
		
		IF ([vdvDialer, DIAL_OFF_HOOK_FB])
		{
			SEND_COMMAND vdvDialer,"'DTMF-',cDigit";
		}
		
		SEND_COMMAND dvPanel,"'^TXT-131,0,',cDialNumber";
	}
}

BUTTON_EVENT[dvPanel, 143]					// BACK SPACE
{
	PUSH:
	{
		IF (LENGTH_STRING(cDialNumber))
		{
			TO[BUTTON.INPUT];

			SET_LENGTH_STRING(cDialNumber, LENGTH_STRING(cDialNumber) - 1);
			SEND_COMMAND dvPanel,"'^TXT-131,0,',cDialNumber";
		}
	}
}

BUTTON_EVENT[dvPanel, 144]					// CLEAR
{
	PUSH:
	{
		TO[BUTTON.INPUT];

		cDialNumber = "";
		SEND_COMMAND dvPanel,"'^TXT-131,0,',cDialNumber";
	}
}

BUTTON_EVENT[dvPanel, 145]					// SEND DTMF
{
	PUSH:
	{
		bDTMFSend = !bDTMFSend;
	}
}

////////////////////////////////////////////////////////////
// CALL CONTROL
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, 146]					// OFF HOOK
{
	PUSH:
	{
		ON[vdvDialer, DIAL_OFF_HOOK_ON];
	}
}

BUTTON_EVENT[dvPanel, 147]					// ON HOOK
{
	PUSH:
	{
		OFF[vdvDialer, DIAL_OFF_HOOK_ON];
	}
}

BUTTON_EVENT[dvPanel, 148]					// DIAL NUMBER
{
	PUSH:
	{
		IF (LENGTH_STRING(cDialNumber) > 0)
		{
			TO[BUTTON.INPUT];
			
			SEND_COMMAND vdvDialer,"'DIALNUMBER-',cDialNumber";
		}
	}
}

BUTTON_EVENT[dvPanel, 149]					// REDIAL
{
	PUSH:
	{
		TO[BUTTON.INPUT];
		
		PULSE[vdvDialer, DIAL_REDIAL];
	}
}

BUTTON_EVENT[dvPanel, 150]					// FLASH
{
	PUSH:
	{
		TO[BUTTON.INPUT];
		
		PULSE[vdvDialer, DIAL_FLASH_HOOK];
	}
}

BUTTON_EVENT[dvPanel, 151]					// AUTO-ANSWER
{
	PUSH:
	{
		PULSE[vdvDialer, DIAL_AUTO_ANSWER];
	}
}

////////////////////////////////////////////////////////////
// DIALER COMMUNICATION
////////////////////////////////////////////////////////////
DATA_EVENT[vdvDialer]
{
	COMMAND:
	{
		IF (FIND_STRING(DATA.TEXT,'INCOMINGCALL-',1) > 0)
		{
			REMOVE_STRING(DATA.TEXT,'INCOMINGCALL-',1);
			
			SEND_COMMAND dvPanel,"'^TXT-151,0,',DATA.TEXT";
			
			IF ([vdvDialer, DIAL_AUTO_ANSWER_FB] == FALSE)
				SEND_COMMAND dvPanel,'@PPN-TI Incoming Call';
		}
	}
}

CHANNEL_EVENT[vdvDialer, DIAL_OFF_HOOK_FB]
{
	ON:
	{
		SEND_COMMAND dvPanel,'@PPF-TI Incoming Call';
		SEND_COMMAND dvPanel,"'^TXT-151,0,'";
	}
}
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

////////////////////////////////////////////////////////////
// SEND DTMF FEEDBACK
////////////////////////////////////////////////////////////
[dvPanel, 145] = (bDTMFSend == TRUE);

////////////////////////////////////////////////////////////
// CALL CONTROL FEEDBACK
////////////////////////////////////////////////////////////
[dvPanel, 146] = [vdvDialer, DIAL_OFF_HOOK_FB];
[dvPanel, 147] = ![vdvDialer, DIAL_OFF_HOOK_FB];
[dvPanel, 151] = [vdvDialer, DIAL_AUTO_ANSWER_FB];

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)
