MODULE_NAME='ClearoneConvergePro2VOIPDialer' (DEV vdvDialer, DEV dvPanel)
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/04/2006  AT: 11:33:16        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)    
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
#INCLUDE 'SNAPI'

DEFINE_CONSTANT

tlVOIPCall1LED = 2
tlVOIPCall2LED = 3
tlVOIPCall3LED = 4
tlVOIPCall4LED = 5
tlVOIPCall5LED = 6
tlVOIPDialer	= 7

TL_FEEDBACK = 1;
LONG TL_FEEDBACK_TIMES[] = {300};

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE CHAR cDialNumber[25]
VOLATILE CHAR ForwardState[14]
VOLATILE INTEGER CallSelected
Long lTimeVOIPCall1LED[] = {800}
Long lTimeVOIPCall2LED[] = {800}
Long lTimeVOIPCall3LED[] = {800}
Long lTimeVOIPCall4LED[] = {800}
Long lTimeVOIPCall5LED[] = {800}

char bBlink;
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

([dvPanel, 163] .. [dvPanel, 164])
([dvPanel, 165] .. [dvPanel, 166])

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

TIMELINE_CREATE(TL_FEEDBACK, TL_FEEDBACK_TIMES, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT);

TIMELINE_CREATE (tlVOIPCall1LED, lTimeVOIPCall1LED, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT)
TIMELINE_CREATE (tlVOIPCall2LED, lTimeVOIPCall2LED, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT)
TIMELINE_CREATE (tlVOIPCall3LED, lTimeVOIPCall3LED, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT)
TIMELINE_CREATE (tlVOIPCall4LED, lTimeVOIPCall4LED, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT)
TIMELINE_CREATE (tlVOIPCall5LED, lTimeVOIPCall5LED, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT)

TIMELINE_PAUSE(tlVOIPCall1LED)
TIMELINE_PAUSE(tlVOIPCall2LED)
TIMELINE_PAUSE(tlVOIPCall3LED)
TIMELINE_PAUSE(tlVOIPCall4LED)
TIMELINE_PAUSE(tlVOIPCall5LED)

OFF [dvPanel, 171]
OFF [dvPanel, 172]
OFF [dvPanel, 173]
OFF [dvPanel, 174]
OFF [dvPanel, 175]

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

TIMELINE_EVENT [tlVOIPCall1LED]
TIMELINE_EVENT [tlVOIPCall2LED]
TIMELINE_EVENT [tlVOIPCall3LED]
TIMELINE_EVENT [tlVOIPCall4LED]
TIMELINE_EVENT [tlVOIPCall5LED]
{
	[dvPanel, (TIMELINE.ID + 170)] = ![dvPanel, (TIMELINE.ID + 170)]
}
////////////////////////////////////////////////////////////
// DIAL KEYPAD 
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, 131]					// DIGIT 0
BUTTON_EVENT[dvPanel, 132]					// DIGIT 1
BUTTON_EVENT[dvPanel, 133]					// DIGIT 2
BUTTON_EVENT[dvPanel, 134]					// DIGIT 3
BUTTON_EVENT[dvPanel, 135]					// DIGIT 4
BUTTON_EVENT[dvPanel, 136]					// DIGIT 5
BUTTON_EVENT[dvPanel, 137]					// DIGIT 6
BUTTON_EVENT[dvPanel, 138]					// DIGIT 7
BUTTON_EVENT[dvPanel, 139]					// DIGIT 8
BUTTON_EVENT[dvPanel, 140]					// DIGIT 9
BUTTON_EVENT[dvPanel, 141]					// DIGIT *
BUTTON_EVENT[dvPanel, 142]					// DIGIT #
{                   
	PUSH:
	{
		STACK_VAR INTEGER nButton;
		STACK_VAR CHAR cDigit[1];
		
		nButton = BUTTON.INPUT.CHANNEL - 131;
		
		TO[BUTTON.INPUT];
		
		SWITCH (nButton)
		{
			CASE 10:
			{
				cDigit = '*'
				BREAK;
			}
			CASE 11:
			{
				cDigit = '#'
				BREAK;
			}
			DEFAULT:
			{
				cDigit = ITOA(nButton)
				BREAK;
			}
		}
		
		cDialNumber = "cDialNumber, cDigit"
		
		IF ([vdvDialer, DIAL_OFF_HOOK_FB])
		{
			SEND_COMMAND vdvDialer,"'DTMF-',cDigit"
		}
		
		SEND_COMMAND dvPanel,"'^TXT-131,0,',cDialNumber"
	}
}

BUTTON_EVENT[dvPanel, 143]					// BACK SPACE
{
	PUSH:
	{
		IF (LENGTH_STRING(cDialNumber))
		{
			TO[BUTTON.INPUT];
			
			SET_LENGTH_STRING(cDialNumber, LENGTH_STRING(cDialNumber) - 1)
			SEND_COMMAND dvPanel,"'^TXT-131,0,',cDialNumber"
		}
	}
}

BUTTON_EVENT[dvPanel, 144]					// CLEAR
{
	PUSH:
	{
		TO[BUTTON.INPUT];
		
		cDialNumber = "";
		SEND_COMMAND dvPanel,"'^TXT-131,0,',cDialNumber"
	}
}

////////////////////////////////////////////////////////////
// CALL CONTROL
////////////////////////////////////////////////////////////
BUTTON_EVENT [dvPanel, 146]					// OFF HOOK
{
	PUSH:
	{
		ON [vdvDialer, DIAL_OFF_HOOK_ON];
	}
}

BUTTON_EVENT [dvPanel, 147]					// ON HOOK
{
	PUSH:
	{
		OFF [vdvDialer, DIAL_OFF_HOOK_ON];
	}
}

BUTTON_EVENT [dvPanel, 148]					// DIAL NUMBER
{
	PUSH:
	{
		IF (LENGTH_STRING(cDialNumber) > 0)
		{
			TO [BUTTON.INPUT];
			
			SEND_COMMAND vdvDialer, "'DIALNUMBER-', cDialNumber"
		}
	}
}

BUTTON_EVENT [dvPanel, 149]					// REDIAL
{
	PUSH:
	{
		TO [BUTTON.INPUT];
		
		PULSE [vdvDialer, DIAL_REDIAL];
	}
}

BUTTON_EVENT [dvPanel, 150]					// HOLD
{
	PUSH:
	{
		TO [BUTTON.INPUT]
		PULSE [vdvDialer, 301]
	}
}

////////////////////////////////////////////////////////////
// CALL SELECTION
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, 151]					// SELECT CALL 1
BUTTON_EVENT[dvPanel, 152]					// SELECT CALL 2
BUTTON_EVENT[dvPanel, 153]					// SELECT CALL 3
BUTTON_EVENT[dvPanel, 154]					// SELECT CALL 4
BUTTON_EVENT[dvPanel, 155]					// SELECT CALL 5
{
	PUSH:
	{
		To [BUTTON.INPUT]
		CallSelected = BUTTON.INPUT.CHANNEL - 150
		SEND_COMMAND vdvDialer, "'VOIP_CALL_SELECT-', ITOA(CallSelected)"
	}
}

////////////////////////////////////////////////////////////
// CONFERENCE SELECTION
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, 156]					// SELECT CALL 1 CONFERENCE
BUTTON_EVENT[dvPanel, 157]					// SELECT CALL 2 CONFERENCE
BUTTON_EVENT[dvPanel, 158]					// SELECT CALL 3 CONFERENCE
BUTTON_EVENT[dvPanel, 159]					// SELECT CALL 4 CONFERENCE
BUTTON_EVENT[dvPanel, 160]					// SELECT CALL 5 CONFERENCE
{
	PUSH:
	{
		To [BUTTON.INPUT]
		PULSE [vdvDialer, (155 + BUTTON.INPUT.CHANNEL)]
	}
}

////////////////////////////////////////////////////////////
// TRANSFERING
////////////////////////////////////////////////////////////

BUTTON_EVENT[dvPanel, 161]					// TRANSFER
BUTTON_EVENT[dvPanel, 162]					// BLIND TRANSFER
{
	PUSH:
	{
		TO [BUTTON.INPUT]
		PULSE [vdvDialer, (BUTTON.INPUT.CHANNEL + 146)]
	}
}

////////////////////////////////////////////////////////////
// CALL FORWARD
////////////////////////////////////////////////////////////

//AVAILABLE OPTIONS:
//DISABLED
//UNCONDITIONAL
//BUSY
//NO_REPLY

BUTTON_EVENT[dvPanel, 163]					// CALL FORWARD ENABLE
{
	PUSH:
	{
		TO [BUTTON.INPUT]
		SEND_COMMAND vdvDialer, 'VOIP_CALL_FORWARD_MODE-UNCONDITIONAL'
	}
}

BUTTON_EVENT[dvPanel, 164]					// CALL FORWARD DISABLE
{
	PUSH:
	{
		TO [BUTTON.INPUT]
		SEND_COMMAND vdvDialer, 'VOIP_CALL_FORWARD_MODE-DISABLED'
	}
}

////////////////////////////////////////////////////////////
// DO NOT DISTURB
////////////////////////////////////////////////////////////

BUTTON_EVENT[dvPanel, 165]					// DO NOT DISTURB ENABLE
{
	PUSH:
	{
		SEND_COMMAND vdvDialer, 'VOIP_DO_NOT_DISTURB_STATE-DND_CALL_REJECT'
	}
}

BUTTON_EVENT[dvPanel, 166]					// DO NOT DISTURB DISABLE
{
	PUSH:
	{
		SEND_COMMAND vdvDialer, 'VOIP_DO_NOT_DISTURB_STATE-DND_NOT_SET'
	}
}

////////////////////////////////////////////////////////////
// DIALER COMMUNICATION
////////////////////////////////////////////////////////////
DATA_EVENT[vdvDialer]
{
	COMMAND:
	{
		CHAR CallNumber[1]
		CHAR Value[25]
		INTEGER iChannel
		IF (FIND_STRING(DATA.TEXT, 'INCOMINGCALL-',1) > 0)
		{
			REMOVE_STRING(DATA.TEXT, 'INCOMINGCALL-',1)
			
			SEND_COMMAND dvPanel, "'^TXT-151,0,',DATA.TEXT"
			
			IF ([vdvDialer, DIAL_AUTO_ANSWER_FB] == FALSE)
			{
				SEND_COMMAND dvPanel, '@PPN-TI Incoming Call'
			}
		}
		ELSE IF (FIND_STRING(DATA.TEXT, 'VOIP_CALL_SELECT-', 1) > 0)
		{
			REMOVE_STRING(DATA.TEXT, 'VOIP_CALL_SELECT-', 1)
			CallSelected = ATOI(DATA.TEXT)
		}
		ELSE IF (FIND_STRING(DATA.TEXT, 'VOIP_CALL_STATE-', 1) > 0)
		{
			REMOVE_STRING(DATA.TEXT, 'VOIP_CALL_STATE-', 1)
			CallNumber = MID_STRING(DATA.TEXT, 1, 1)
			Value = MID_STRING(DATA.TEXT, 3, LENGTH_STRING(DATA.TEXT) - 2)
			SEND_COMMAND dvPanel, "'^TXT-', CallNumber, ',0,', Value"
		}
		ELSE IF (FIND_STRING(DATA.TEXT, 'VOIP_DO_NOT_DISTURB_STATE-', 1) > 0)
		{
			REMOVE_STRING(DATA.TEXT, 'VOIP_DO_NOT_DISTURB_STATE-', 1)
			Value = DATA.TEXT
			IF (FIND_STRING(Value, 'DND_NOT_SET', 1) > 0)
			{
				ON [dvPanel, 166]
			}
			ELSE IF (FIND_STRING(Value, 'DND_CALL_REJECT', 1) > 0)
			{
				ON [dvPanel, 165]
			}
		}
		ELSE IF (FIND_STRING(DATA.TEXT, 'VOIP_CALL_FORWARD_MODE-', 1) > 0)
		{
			REMOVE_STRING(DATA.TEXT, 'VOIP_CALL_FORWARD_MODE-', 1)
			Value = DATA.TEXT
			forwardState = Value;
		}
		ELSE IF (FIND_STRING(DATA.TEXT, 'VOIP_CALL_LED_STATE-', 1) > 0)
		{
			REMOVE_STRING(DATA.TEXT, 'VOIP_CALL_LED_STATE-', 1)
			CallNumber = MID_STRING(DATA.TEXT, 1, 1)
			Value = MID_STRING(DATA.TEXT, 3, LENGTH_STRING(DATA.TEXT) - 2)
			iChannel = ATOI(CallNumber) + 170
			IF (FIND_STRING(Value, 'OFF', 1) > 0)
			{
				OFF [dvPanel, iChannel]
				SWITCH (ATOI(CallNumber))
				{
					CASE 1:
					{
						TIMELINE_PAUSE(tlVOIPCall1LED)
					}
					Case 2:
					{
						TIMELINE_PAUSE(tlVOIPCall2LED)
					}
					Case 3:
					{
						TIMELINE_PAUSE(tlVOIPCall3LED)
					}
					Case 4:
					{
						TIMELINE_PAUSE(tlVOIPCall4LED)
					}
					Case 5:
					{
						TIMELINE_PAUSE(tlVOIPCall5LED)
					}
				}
			}
			ELSE IF (FIND_STRING(Value, 'ON', 1) > 0)
			{
				ON [dvPanel, iChannel]
				SWITCH (ATOI(CallNumber))
				{
					CASE 1:
					{
						TIMELINE_PAUSE(tlVOIPCall1LED)
					}
					Case 2:
					{
						TIMELINE_PAUSE(tlVOIPCall2LED)
					}
					Case 3:
					{
						TIMELINE_PAUSE(tlVOIPCall3LED)
					}
					Case 4:
					{
						TIMELINE_PAUSE(tlVOIPCall4LED)
					}
					Case 5:
					{
						TIMELINE_PAUSE(tlVOIPCall5LED)
					}
				}
			}
			ELSE IF (FIND_STRING(Value, 'BLINK', 1) > 0)
			{
				SWITCH (ATOI(CallNumber))
				{
					CASE 1:
					{
						TIMELINE_RESTART(tlVOIPCall1LED)
					}
					Case 2:
					{
						TIMELINE_RESTART(tlVOIPCall2LED)
					}
					Case 3:
					{
						TIMELINE_RESTART(tlVOIPCall3LED)
					}
					Case 4:
					{
						TIMELINE_RESTART(tlVOIPCall4LED)
					}
					Case 5:
					{
						TIMELINE_RESTART(tlVOIPCall5LED)
					}
				}
			}
		}
	}
}

CHANNEL_EVENT[vdvDialer, DIAL_OFF_HOOK_FB]
{
	ON:
	{
		SEND_COMMAND dvPanel,'@PPF-TI Incoming Call';
		SEND_COMMAND dvPanel,"'^TXT-151,0,'";
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	WAIT 5
		bBlink = !bBlink;
		
	////////////////////////////////////////////////////////////
	// CALL CONTROL FEEDBACK
	////////////////////////////////////////////////////////////
	[dvPanel, 146] = [vdvDialer, DIAL_OFF_HOOK_FB]
	[dvPanel, 147] = ![vdvDialer, DIAL_OFF_HOOK_FB]
	[dvPanel, 151] = [vdvDialer, DIAL_AUTO_ANSWER_FB]
	[dvPanel, 164] = (FIND_STRING(ForwardState,'INACTIVE',1) > 0);
	[dvPanel, 163] = ((FIND_STRING(ForwardState,'INACTIVE',1) == 0 && FIND_STRING(ForwardState,'ACTIVE',1)) || (FIND_STRING(ForwardState,'INPROCESS',1) && bBlink));
}
(*****************************************************************)
(*                       END OF PROGRAM                          *)
(*                                                               *)
(*         !!!  DO NOT PUT ANY CODE BELOW THIS COMMENT  !!!      *)
(*                                                               *)
(*****************************************************************)
